#ifndef __TORTURE_RPC_PROTO_H__
#define __TORTURE_RPC_PROTO_H__

#undef _PRINTF_ATTRIBUTE
#define _PRINTF_ATTRIBUTE(a1, a2) PRINTF_ATTRIBUTE(a1, a2)
/* This file was automatically generated by mkproto.pl. DO NOT EDIT */

#ifndef _PUBLIC_
#define _PUBLIC_
#endif


/* The following definitions come from torture/rpc/join.c  */

BOOL torture_rpc_join(struct torture_context *torture);

/* The following definitions come from torture/rpc/lsa.c  */

BOOL test_lsa_OpenPolicy2(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, 
			  struct policy_handle **handle);
BOOL test_many_LookupSids(struct dcerpc_pipe *p, 
			  TALLOC_CTX *mem_ctx, 
			  struct policy_handle *handle);
BOOL test_lsa_Close(struct dcerpc_pipe *p, 
		    TALLOC_CTX *mem_ctx, 
		    struct policy_handle *handle);
BOOL torture_rpc_lsa(struct torture_context *torture);
BOOL torture_rpc_lsa_get_user(struct torture_context *torture);

/* The following definitions come from torture/rpc/lsa_lookup.c  */

BOOL torture_rpc_lsa_lookup(struct torture_context *torture);

/* The following definitions come from torture/rpc/session_key.c  */

BOOL torture_rpc_lsa_secrets(struct torture_context *torture) ;

/* The following definitions come from torture/rpc/echo.c  */

struct torture_suite *torture_rpc_echo(void);

/* The following definitions come from torture/rpc/dcom.c  */

BOOL torture_rpc_dcom(void);

/* The following definitions come from torture/rpc/dfs.c  */

struct torture_suite *torture_rpc_dfs(void);

/* The following definitions come from torture/rpc/drsuapi.c  */

BOOL test_DsBind(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, 
		 struct DsPrivate *priv);
BOOL test_DsUnbind(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, 
		   struct DsPrivate *priv);
BOOL torture_rpc_drsuapi(struct torture_context *torture);

/* The following definitions come from torture/rpc/drsuapi_cracknames.c  */

BOOL test_DsCrackNames(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, 
			      struct DsPrivate *priv, const char *test_dc);
BOOL torture_rpc_drsuapi_cracknames(struct torture_context *torture);

/* The following definitions come from torture/rpc/dssync.c  */

BOOL torture_rpc_dssync(struct torture_context *torture);

/* The following definitions come from torture/rpc/spoolss.c  */

BOOL torture_rpc_spoolss(struct torture_context *torture);

/* The following definitions come from torture/rpc/unixinfo.c  */

struct torture_suite *torture_rpc_unixinfo(void);

/* The following definitions come from torture/rpc/samr.c  */

BOOL test_samr_handle_Close(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, 
				   struct policy_handle *handle);
BOOL test_ChangePasswordUser3(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, 
			      const char *account_string,
			      int policy_min_pw_len,
			      char **password,
			      const char *newpass,
			      NTTIME last_password_change,
			      BOOL handle_reject_reason);
BOOL test_DeleteUser_byname(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, 
			    struct policy_handle *handle, const char *name);
BOOL torture_rpc_samr(struct torture_context *torture);
BOOL torture_rpc_samr_users(struct torture_context *torture);
BOOL torture_rpc_samr_passwords(struct torture_context *torture);

/* The following definitions come from torture/rpc/wkssvc.c  */

struct torture_suite *torture_rpc_wkssvc(void);

/* The following definitions come from torture/rpc/srvsvc.c  */

BOOL torture_rpc_srvsvc(struct torture_context *torture);

/* The following definitions come from torture/rpc/svcctl.c  */

BOOL torture_rpc_svcctl(struct torture_context *torture);

/* The following definitions come from torture/rpc/atsvc.c  */

struct torture_suite *torture_rpc_atsvc(void);

/* The following definitions come from torture/rpc/eventlog.c  */

struct torture_suite *torture_rpc_eventlog(void);

/* The following definitions come from torture/rpc/epmapper.c  */

BOOL torture_rpc_epmapper(struct torture_context *torture);

/* The following definitions come from torture/rpc/winreg.c  */

BOOL torture_rpc_winreg(struct torture_context *torture);

/* The following definitions come from torture/rpc/initshutdown.c  */

BOOL torture_rpc_initshutdown(struct torture_context *torture);

/* The following definitions come from torture/rpc/oxidresolve.c  */

BOOL torture_rpc_oxidresolve(struct torture_context *torture);

/* The following definitions come from torture/rpc/remact.c  */

BOOL torture_rpc_remact(struct torture_context *torture);

/* The following definitions come from torture/rpc/mgmt.c  */

BOOL torture_rpc_mgmt(struct torture_context *torture);

/* The following definitions come from torture/rpc/scanner.c  */

BOOL torture_rpc_scanner(struct torture_context *torture);

/* The following definitions come from torture/rpc/autoidl.c  */

BOOL torture_rpc_autoidl(struct torture_context *torture);

/* The following definitions come from torture/rpc/countcalls.c  */

BOOL torture_rpc_countcalls(struct torture_context *torture);

/* The following definitions come from torture/rpc/testjoin.c  */

struct test_join *torture_create_testuser(const char *username, 
					  const char *domain,
					  uint16_t acct_type,
					  const char **random_password);
_PUBLIC_ struct test_join *torture_join_domain(const char *machine_name, 
				      uint32_t acct_flags,
				      struct cli_credentials **machine_credentials);
struct dcerpc_pipe *torture_join_samr_pipe(struct test_join *join) ;
struct policy_handle *torture_join_samr_user_policy(struct test_join *join) ;
NTSTATUS torture_leave_ads_domain(TALLOC_CTX *mem_ctx, struct libnet_JoinDomain *libnet_r);
_PUBLIC_ void torture_leave_domain(struct test_join *join);
_PUBLIC_ const struct dom_sid *torture_join_sid(struct test_join *join);
const struct dom_sid *torture_join_user_sid(struct test_join *join);
const char *torture_join_dom_netbios_name(struct test_join *join);
const char *torture_join_dom_dns_name(struct test_join *join);
struct test_join_ads_dc *torture_join_domain_ads_dc(const char *machine_name, 
						    const char *domain,
						    struct cli_credentials **machine_credentials);
void torture_leave_domain_ads_dc(struct test_join_ads_dc *join);

/* The following definitions come from torture/rpc/schannel.c  */

BOOL test_netlogon_ex_ops(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, 
			  struct cli_credentials *credentials, 
			  struct creds_CredentialState *creds);
BOOL torture_rpc_schannel(struct torture_context *torture);

/* The following definitions come from torture/rpc/netlogon.c  */

BOOL test_netlogon_ops(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, 
			      struct cli_credentials *credentials, 
			      struct creds_CredentialState *creds);
BOOL torture_rpc_netlogon(struct torture_context *torture);

/* The following definitions come from torture/rpc/samlogon.c  */

BOOL test_InteractiveLogon(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx,
			   struct creds_CredentialState *creds, 
			   const char *comment,
			   const char *workstation_name,
			   const char *account_domain, const char *account_name,
			   const char *plain_pass, uint32_t parameter_control, 
			   NTSTATUS expected_error);
BOOL torture_rpc_samlogon(struct torture_context *torture);

/* The following definitions come from torture/rpc/samsync.c  */

BOOL torture_rpc_samsync(struct torture_context *torture);

/* The following definitions come from torture/rpc/rot.c  */

BOOL torture_rpc_rot(struct torture_context *torture);

/* The following definitions come from torture/rpc/bind.c  */

BOOL torture_multi_bind(struct torture_context *torture) ;

/* The following definitions come from torture/rpc/dssetup.c  */

BOOL test_DsRoleGetPrimaryDomainInformation(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx);
BOOL torture_rpc_dssetup(struct torture_context *torture);

/* The following definitions come from torture/rpc/alter_context.c  */

BOOL torture_rpc_alter_context(struct torture_context *torture);

/* The following definitions come from torture/rpc/bench.c  */

BOOL torture_bench_rpc(struct torture_context *torture);

/* The following definitions come from torture/rpc/samba3rpc.c  */

BOOL torture_bind_authcontext(struct torture_context *torture) ;
BOOL torture_bind_samba3(struct torture_context *torture) ;
BOOL torture_netlogon_samba3(struct torture_context *torture);
BOOL torture_samba3_sessionkey(struct torture_context *torture);
NTSTATUS secondary_tcon(TALLOC_CTX *mem_ctx,
			struct smbcli_session *session,
			const char *sharename,
			struct smbcli_tree **res);
BOOL torture_samba3_rpc_getusername(struct torture_context *torture);
BOOL torture_samba3_rpc_srvsvc(struct torture_context *torture);
BOOL try_tcon(TALLOC_CTX *mem_ctx,
	      struct security_descriptor *orig_sd,
	      struct smbcli_session *session,
	      const char *sharename, const struct dom_sid *user_sid,
	      unsigned int access_mask, NTSTATUS expected_tcon,
	      NTSTATUS expected_mkdir);
BOOL torture_samba3_rpc_sharesec(struct torture_context *torture);
BOOL torture_samba3_rpc_lsa(struct torture_context *torture);
BOOL torture_samba3_rpc_spoolss(struct torture_context *torture);
BOOL torture_samba3_rpc_wkssvc(struct torture_context *torture);
BOOL torture_samba3_rpc_winreg(struct torture_context *torture);

/* The following definitions come from torture/rpc/rpc.c  */

_PUBLIC_ NTSTATUS torture_rpc_connection(TALLOC_CTX *parent_ctx, 
				struct dcerpc_pipe **p, 
				const struct dcerpc_interface_table *table);
NTSTATUS torture_rpc_connection_transport(TALLOC_CTX *parent_ctx, 
					  struct dcerpc_pipe **p, 
					  const struct dcerpc_interface_table *table,
					  enum dcerpc_transport_t transport);
_PUBLIC_ struct torture_tcase *torture_suite_add_rpc_iface_tcase(struct torture_suite *suite, 
								const char *name,
								const struct dcerpc_interface_table *table);
_PUBLIC_ struct torture_test *torture_rpc_tcase_add_test(
					struct torture_tcase *tcase, 
					const char *name, 
					bool (*fn) (struct torture_context *, struct dcerpc_pipe *));
NTSTATUS torture_rpc_init(void);

/* The following definitions come from torture/rpc/async_bind.c  */

BOOL torture_async_bind(struct torture_context *torture);
#undef _PRINTF_ATTRIBUTE
#define _PRINTF_ATTRIBUTE(a1, a2)

#endif /* __TORTURE_RPC_PROTO_H__ */

