#ifndef __TORTURE_UTIL_H__
#define __TORTURE_UTIL_H__

#undef _PRINTF_ATTRIBUTE
#define _PRINTF_ATTRIBUTE(a1, a2) PRINTF_ATTRIBUTE(a1, a2)
/* This file was automatically generated by mkproto.pl. DO NOT EDIT */

#ifndef _PUBLIC_
#define _PUBLIC_
#endif


/* The following definitions come from torture/util.c  */

_PUBLIC_ NTSTATUS torture_temp_dir(TALLOC_CTX *mem_ctx, const char *prefix, 
								   char **tempdir);
BOOL nt_time_equal(NTTIME *t1, NTTIME *t2);
NTSTATUS torture_setup_server(TALLOC_CTX *mem_ctx, 
							  const char *prefix,
							  const char *setupdir_script,
							  const char *smbd_path,
							  pid_t *smbd_pid);
NTSTATUS torture_second_tcon(TALLOC_CTX *mem_ctx,
			     struct smbcli_session *session,
			     const char *sharename,
			     struct smbcli_tree **res);

/* The following definitions come from torture/util_smb.c  */

_PUBLIC_ bool torture_setup_dir(struct smbcli_state *cli, const char *dname);
NTSTATUS create_directory_handle(struct smbcli_tree *tree, const char *dname, int *fnum);
_PUBLIC_ int create_complex_file(struct smbcli_state *cli, TALLOC_CTX *mem_ctx, const char *fname);
int create_complex_dir(struct smbcli_state *cli, TALLOC_CTX *mem_ctx, const char *dname);
void *shm_setup(int size);
bool wire_bad_flags(struct smb_wire_string *str, int flags, struct smbcli_state *cli);
void dump_all_info(TALLOC_CTX *mem_ctx, union smb_fileinfo *finfo);
void torture_all_info(struct smbcli_tree *tree, const char *fname);
bool torture_set_file_attribute(struct smbcli_tree *tree, const char *fname, uint16_t attrib);
NTSTATUS torture_set_sparse(struct smbcli_tree *tree, int fnum);
NTSTATUS torture_check_ea(struct smbcli_state *cli, 
			  const char *fname, const char *eaname, const char *value);
_PUBLIC_ bool torture_open_connection_share(TALLOC_CTX *mem_ctx,
				   struct smbcli_state **c, 
				   const char *hostname, 
				   const char *sharename,
				   struct event_context *ev);
_PUBLIC_ bool torture_open_connection(struct smbcli_state **c, int conn_index);
_PUBLIC_ bool torture_open_connection_ev(struct smbcli_state **c,
					 int conn_index,
					 struct event_context *ev);
_PUBLIC_ bool torture_close_connection(struct smbcli_state *c);
_PUBLIC_ bool check_error(const char *location, struct smbcli_state *c, 
		 uint8_t eclass, uint32_t ecode, NTSTATUS nterr);
double torture_create_procs(struct torture_context *tctx, 
							bool (*fn)(struct torture_context *, struct smbcli_state *, int), bool *result);
_PUBLIC_ struct torture_test *torture_suite_add_smb_multi_test(
									struct torture_suite *suite,
									const char *name,
									bool (*run) (struct torture_context *,
												 struct smbcli_state *,
												int i));
_PUBLIC_ struct torture_test *torture_suite_add_2smb_test(
									struct torture_suite *suite,
									const char *name,
									bool (*run) (struct torture_context *,
												struct smbcli_state *,
												struct smbcli_state *));
_PUBLIC_ struct torture_test *torture_suite_add_1smb_test(
									struct torture_suite *suite,
									const char *name,
									bool (*run) (struct torture_context *,
												struct smbcli_state *));
#undef _PRINTF_ATTRIBUTE
#define _PRINTF_ATTRIBUTE(a1, a2)

#endif /* __TORTURE_UTIL_H__ */

