#ifndef __WINBIND_WB_PROTO_H__
#define __WINBIND_WB_PROTO_H__

#undef _PRINTF_ATTRIBUTE
#define _PRINTF_ATTRIBUTE(a1, a2) PRINTF_ATTRIBUTE(a1, a2)
/* This file was automatically generated by mkproto.pl. DO NOT EDIT */

#ifndef _PUBLIC_
#define _PUBLIC_
#endif


/* The following definitions come from winbind/wb_server.c  */

void wbsrv_terminate_connection(struct wbsrv_connection *wbconn, const char *reason);
NTSTATUS server_service_winbind_init(void);

/* The following definitions come from winbind/wb_irpc.c  */

NTSTATUS wbsrv_init_irpc(struct wbsrv_service *service);

/* The following definitions come from winbind/wb_samba3_protocol.c  */

NTSTATUS wbsrv_samba3_packet_full_request(void *private, DATA_BLOB blob, size_t *size);
NTSTATUS wbsrv_samba3_pull_request(DATA_BLOB blob, struct wbsrv_connection *wbconn,
				   struct wbsrv_samba3_call **_call);
NTSTATUS wbsrv_samba3_handle_call(struct wbsrv_samba3_call *s3call);
NTSTATUS wbsrv_samba3_send_reply(struct wbsrv_samba3_call *call);
NTSTATUS wbsrv_samba3_process(void *private, DATA_BLOB blob);

/* The following definitions come from winbind/wb_samba3_cmd.c  */

NTSTATUS wbsrv_samba3_interface_version(struct wbsrv_samba3_call *s3call);
NTSTATUS wbsrv_samba3_info(struct wbsrv_samba3_call *s3call);
NTSTATUS wbsrv_samba3_domain_name(struct wbsrv_samba3_call *s3call);
NTSTATUS wbsrv_samba3_netbios_name(struct wbsrv_samba3_call *s3call);
NTSTATUS wbsrv_samba3_priv_pipe_dir(struct wbsrv_samba3_call *s3call);
NTSTATUS wbsrv_samba3_ping(struct wbsrv_samba3_call *s3call);
NTSTATUS wbsrv_samba3_check_machacc(struct wbsrv_samba3_call *s3call);
NTSTATUS wbsrv_samba3_getdcname(struct wbsrv_samba3_call *s3call);
NTSTATUS wbsrv_samba3_userdomgroups(struct wbsrv_samba3_call *s3call);
NTSTATUS wbsrv_samba3_usersids(struct wbsrv_samba3_call *s3call);
NTSTATUS wbsrv_samba3_lookupname(struct wbsrv_samba3_call *s3call);
NTSTATUS wbsrv_samba3_lookupsid(struct wbsrv_samba3_call *s3call);
NTSTATUS wbsrv_samba3_pam_auth_crap(struct wbsrv_samba3_call *s3call);
NTSTATUS wbsrv_samba3_pam_auth(struct wbsrv_samba3_call *s3call);
NTSTATUS wbsrv_samba3_list_trustdom(struct wbsrv_samba3_call *s3call);

/* The following definitions come from winbind/wb_init_domain.c  */

struct composite_context *wb_init_domain_send(TALLOC_CTX *mem_ctx,
					      struct wbsrv_service *service,
					      struct wb_dom_info *dom_info);
NTSTATUS wb_init_domain_recv(struct composite_context *c,
			     TALLOC_CTX *mem_ctx,
			     struct wbsrv_domain **result);
NTSTATUS wb_init_domain(TALLOC_CTX *mem_ctx, struct wbsrv_service *service,
			struct wb_dom_info *dom_info,
			struct wbsrv_domain **result);

/* The following definitions come from winbind/wb_dom_info.c  */

struct composite_context *wb_get_dom_info_send(TALLOC_CTX *mem_ctx,
					       struct wbsrv_service *service,
					       const char *domain_name,
					       const struct dom_sid *sid);
NTSTATUS wb_get_dom_info_recv(struct composite_context *ctx,
			      TALLOC_CTX *mem_ctx,
			      struct wb_dom_info **result);
NTSTATUS wb_get_dom_info(TALLOC_CTX *mem_ctx,
			 struct wbsrv_service *service,
			 const char *domain_name,
			 const struct dom_sid *sid,
			 struct wb_dom_info **result);

/* The following definitions come from winbind/wb_dom_info_trusted.c  */

struct composite_context *wb_trusted_dom_info_send(TALLOC_CTX *mem_ctx,
						   struct wbsrv_service *service,
						   const char *domain_name,
						   const struct dom_sid *sid);
NTSTATUS wb_trusted_dom_info_recv(struct composite_context *ctx,
				  TALLOC_CTX *mem_ctx,
				  struct wb_dom_info **result);
NTSTATUS wb_trusted_dom_info(TALLOC_CTX *mem_ctx,
			     struct wbsrv_service *service,
			     const char *domain_name,
			     const struct dom_sid *sid,
			     struct wb_dom_info **result);

/* The following definitions come from winbind/wb_sid2domain.c  */

struct composite_context *wb_sid2domain_send(TALLOC_CTX *mem_ctx,
					     struct wbsrv_service *service,
					     const struct dom_sid *sid);
NTSTATUS wb_sid2domain_recv(struct composite_context *ctx,
			    struct wbsrv_domain **result);
NTSTATUS wb_sid2domain(TALLOC_CTX *mem_ctx, struct wbsrv_service *service,
		       const struct dom_sid *sid,
		       struct wbsrv_domain **result);

/* The following definitions come from winbind/wb_connect_lsa.c  */

struct composite_context *wb_init_lsa_send(TALLOC_CTX *mem_ctx,
					   struct smbcli_tree *tree,
					   uint8_t auth_type,
					   struct cli_credentials *creds);
NTSTATUS wb_init_lsa_recv(struct composite_context *c,
			  TALLOC_CTX *mem_ctx,
			  struct dcerpc_pipe **lsa_pipe,
			  struct policy_handle **lsa_policy);
struct composite_context *wb_connect_lsa_send(TALLOC_CTX *mem_ctx,
					      struct smbcli_tree *tree,
					      struct cli_credentials *credentials);
NTSTATUS wb_connect_lsa_recv(struct composite_context *c,
			     TALLOC_CTX *mem_ctx,
			     uint8_t *auth_type,
			     struct dcerpc_pipe **lsa_pipe,
			     struct policy_handle **lsa_policy);
NTSTATUS wb_connect_lsa(TALLOC_CTX *mem_ctx,
			struct smbcli_tree *tree,
			struct cli_credentials *credentials,
			uint8_t *auth_type,
			struct dcerpc_pipe **lsa_pipe,
			struct policy_handle **lsa_policy);

/* The following definitions come from winbind/wb_connect_sam.c  */

struct composite_context *wb_connect_sam_send(TALLOC_CTX *mem_ctx,
					      struct smbcli_tree *tree,
					      uint8_t auth_type,
					      struct cli_credentials *creds,
					      const struct dom_sid *domain_sid);
NTSTATUS wb_connect_sam_recv(struct composite_context *c,
			     TALLOC_CTX *mem_ctx,
			     struct dcerpc_pipe **samr_pipe,
			     struct policy_handle **connect_handle,
			     struct policy_handle **domain_handle);
NTSTATUS wb_connect_sam(TALLOC_CTX *mem_ctx,
			struct smbcli_tree *tree,
			uint8_t auth_type,
			struct cli_credentials *creds,
			const struct dom_sid *domain_sid,
			struct dcerpc_pipe **samr_pipe,
			struct policy_handle **connect_handle,
			struct policy_handle **domain_handle);

/* The following definitions come from winbind/wb_cmd_lookupname.c  */

struct composite_context *wb_cmd_lookupname_send(TALLOC_CTX *mem_ctx,
						 struct wbsrv_service *service,
						 const char *dom_name,
						 const char *name);
NTSTATUS wb_cmd_lookupname_recv(struct composite_context *c,
				TALLOC_CTX *mem_ctx,
				struct wb_sid_object **sid);
NTSTATUS wb_cmd_lookupname(TALLOC_CTX *mem_ctx,
			   struct wbsrv_service *service,
			   const char *dom_name,
			   const char *name,
			   struct wb_sid_object **sid);

/* The following definitions come from winbind/wb_cmd_lookupsid.c  */

struct composite_context *wb_cmd_lookupsid_send(TALLOC_CTX *mem_ctx,
						struct wbsrv_service *service,
						const struct dom_sid *sid);
NTSTATUS wb_cmd_lookupsid_recv(struct composite_context *c,
			       TALLOC_CTX *mem_ctx,
			       struct wb_sid_object **sid);
NTSTATUS wb_cmd_lookupsid(TALLOC_CTX *mem_ctx, struct wbsrv_service *service,
			  const struct dom_sid *sid,
			  struct wb_sid_object **name);

/* The following definitions come from winbind/wb_cmd_getdcname.c  */

struct composite_context *wb_cmd_getdcname_send(TALLOC_CTX *mem_ctx,
						struct wbsrv_service *service,
						const char *domain_name);
NTSTATUS wb_cmd_getdcname_recv(struct composite_context *c,
			       TALLOC_CTX *mem_ctx,
			       const char **dcname);

/* The following definitions come from winbind/wb_cmd_userdomgroups.c  */

struct composite_context *wb_cmd_userdomgroups_send(TALLOC_CTX *mem_ctx,
						    struct wbsrv_service *service,
						    const struct dom_sid *sid);
NTSTATUS wb_cmd_userdomgroups_recv(struct composite_context *c,
				   TALLOC_CTX *mem_ctx,
				   int *num_sids, struct dom_sid ***sids);
NTSTATUS wb_cmd_userdomgroups(TALLOC_CTX *mem_ctx,
			      struct wbsrv_service *service,
			      const struct dom_sid *sid,
			      int *num_sids, struct dom_sid ***sids);

/* The following definitions come from winbind/wb_cmd_usersids.c  */

struct composite_context *wb_cmd_usersids_send(TALLOC_CTX *mem_ctx,
					       struct wbsrv_service *service,
					       const struct dom_sid *sid);
NTSTATUS wb_cmd_usersids_recv(struct composite_context *ctx,
			      TALLOC_CTX *mem_ctx,
			      int *num_sids, struct dom_sid ***sids);
NTSTATUS wb_cmd_usersids(TALLOC_CTX *mem_ctx, struct wbsrv_service *service,
			 const struct dom_sid *sid,
			 int *num_sids, struct dom_sid ***sids);

/* The following definitions come from winbind/wb_cmd_list_trustdom.c  */

struct composite_context *wb_cmd_list_trustdoms_send(TALLOC_CTX *mem_ctx,
						     struct wbsrv_service *service);
NTSTATUS wb_cmd_list_trustdoms_recv(struct composite_context *ctx,
				    TALLOC_CTX *mem_ctx,
				    int *num_domains,
				    struct wb_dom_info ***domains);

/* The following definitions come from winbind/wb_pam_auth.c  */

struct composite_context *wb_cmd_pam_auth_crap_send(TALLOC_CTX *mem_ctx,
						    struct wbsrv_service *service,
						    uint32_t logon_parameters,
						    const char *domain,
						    const char *user,
						    const char *workstation,
						    DATA_BLOB chal,
						    DATA_BLOB nt_resp,
						    DATA_BLOB lm_resp);
NTSTATUS wb_cmd_pam_auth_crap_recv(struct composite_context *c,
				   TALLOC_CTX *mem_ctx,
				   DATA_BLOB *info3,
				   struct netr_UserSessionKey *user_session_key,
				   struct netr_LMSessionKey *lm_key,
				   char **unix_username);
NTSTATUS wb_cmd_pam_auth_crap(TALLOC_CTX *mem_ctx,
			      struct wbsrv_service *service,
			      uint32_t logon_parameters,
			      const char *domain, const char *user,
			      const char *workstation,
			      DATA_BLOB chal, DATA_BLOB nt_resp,
			      DATA_BLOB lm_resp,
			      DATA_BLOB *info3,
			      struct netr_UserSessionKey *user_session_key,
			      struct netr_LMSessionKey *lm_key,
			      char **unix_username);
struct composite_context *wb_cmd_pam_auth_send(TALLOC_CTX *mem_ctx,
					       struct wbsrv_service *service,
					       const char *domain,
					       const char *user,
					       const char *password);
NTSTATUS wb_cmd_pam_auth_recv(struct composite_context *c);
NTSTATUS wb_cmd_pam_auth(TALLOC_CTX *mem_ctx, struct wbsrv_service *service,
			 const char *domain, const char *user,
			 const char *password);

/* The following definitions come from winbind/wb_sam_logon.c  */

struct composite_context *wb_sam_logon_send(TALLOC_CTX *mem_ctx,
					    struct wbsrv_service *service,
					    struct winbind_SamLogon *req);
NTSTATUS wb_sam_logon_recv(struct composite_context *c,
			   TALLOC_CTX *mem_ctx,
			   struct winbind_SamLogon *req);
#undef _PRINTF_ATTRIBUTE
#define _PRINTF_ATTRIBUTE(a1, a2)

#endif /* __WINBIND_WB_PROTO_H__ */

